// /services/fetchSystemService.ts
export const fetchSystemService = async () => {
  try {
    if (typeof window === "undefined") return null;

    const isDev = process.env.NODE_ENV === "development";
    const scriptSrc =
      process.env.NEXT_PUBLIC_NODE_ENV === "development"
        ? "/api/cpl/systemAPIHandler"
        : "/CPL?/CPL/SERVICE/system.js";

    await new Promise<void>((resolve, reject) => {
      const script = document.createElement("script");
      script.src = scriptSrc;
      script.async = true;
      script.onload = () => resolve();
      script.onerror = () => reject("❌ Fehler beim Laden von system.js");
      document.body.appendChild(script);
    });

    const {
      win_deviceName,
      win_mac1,
      win_ip,
      win_subnet,
      win_gateway,
      win_cplInternalTimestamp,
      win_ntp1,
      win_ntp2,
      win_ntp3,
      win_ntpTimezone,
      win_ntpActive,
      win_appVersion,
    } = window as any;

    return {
      deviceName: win_deviceName,
      mac1: win_mac1,
      ip: win_ip,
      subnet: win_subnet,
      gateway: win_gateway,
      cplInternalTimestamp: win_cplInternalTimestamp,
      ntp1: win_ntp1,
      ntp2: win_ntp2,
      ntp3: win_ntp3,
      ntpTimezone: win_ntpTimezone,
      ntpActive: win_ntpActive === "1",
      appVersion: win_appVersion,
    };
  } catch (error) {
    console.error("❌ Fehler beim Laden der Systemdaten:", error);
    return null;
  }
};
